typedef struct D3Vertex_type 
{	FxFloat x,y,z;
	FxFloat r,g,b;
} D3Vertex, *D3Vertex_ptr;



typedef struct Normal_type 
{	FxFloat x,y,z;
} Normal, *Normal_ptr;



typedef struct Face_type 
{	int a,b,c;
} Face, *Face_ptr;



typedef struct grVertex_type 
{	FxFloat x,y,z;
	FxFloat oow;
	FxFloat r,g,b;
} grVertex, *grVertex_ptr;


// The Object structure //

typedef struct D3Object_type
{	int Id;				  // Object id number
	int NumVertices;		  // Number of Vertices
	int NumFaces;			  // Number of Faces
	D3Vertex_ptr Vertices_local;	  // Local Coordinate information
	D3Vertex_ptr Vertices_world;	  // Coordinate information after rotation
	grVertex_ptr Vertices_screen;     // 2d screen coordinates
	Normal_ptr   Vertices_normalStat; // All normals of vertices
	Face_ptr     Faces;		  // Faces		
	D3Vertex	 SpotlightStat;   // Information concerning shading
	D3Vertex	 Spotlight;       // Information concerning shading
} D3Object, *D3Object_ptr;


grVertexLayout(GR_PARAM_XY, 0,  GR_PARAM_ENABLE);
grVertexLayout(GR_PARAM_Q,  12, GR_PARAM_ENABLE);
grVertexLayout(GR_PARAM_RGB,16, GR_PARAM_ENABLE);